ogma-core-1.14.0: Ogma: Helper tool to interoperate between Copilot and other languages.

Safe Haskell | None
Language | Haskell2010

Command.FPrimeApp

Description

Create FPrime components that subscribe to obtain data and call Copilot when new values arrive.

Synopsis

- command :: CommandOptions -> IO (Result ErrorCode)
- data CommandOptions = CommandOptions {
  - commandConditionExpr :: Maybe String
  - commandInputFiles :: [FilePath]
  - commandTargetDir :: FilePath
  - commandTemplateDir :: Maybe FilePath
  - commandVariables :: Maybe FilePath
  - commandVariableDB :: Maybe FilePath
  - commandHandlers :: Maybe FilePath
  - commandFormat :: String
  - commandPropFormat :: String
  - commandPropVia :: Maybe String
  - commandExtraVars :: Maybe FilePath
  }
- type ErrorCode = Int

# Documentation

command Source #

Arguments

:: CommandOptions | Options to the ROS backend.
-> IO (Result ErrorCode) |

Generate a new FPrime component connected to Copilot.

data CommandOptions Source #

Options used to customize the conversion of specifications to F' applications.

Constructors

CommandOptions |

Fields

- commandConditionExpr :: Maybe String

  Trigger condition.

- commandInputFiles :: [FilePath]

  Input specification files.

- commandTargetDir :: FilePath

  Target directory where the component should be created.

- commandTemplateDir :: Maybe FilePath

  Directory where the template is to be found.

- commandVariables :: Maybe FilePath

  File containing a list of variables to make available to Copilot.

- commandVariableDB :: Maybe FilePath

  File containing a list of known variables with their types and the message IDs they can be obtained from.

- commandHandlers :: Maybe FilePath

  File containing a list of handlers used in the Copilot specification. The handlers are assumed to receive no arguments.

- commandFormat :: String

  Format of the input file.

- commandPropFormat :: String

  Format used for input properties.

- commandPropVia :: Maybe String

  Use external command to pre-process system properties.

- commandExtraVars :: Maybe FilePath

  File containing additional variables to make available to the template.

type ErrorCode = Int Source #

Encoding of reasons why the command can fail.